-- This file has been generated by Dungeon Editor 1.3.7

-- import standard assets
import "assets/scripts/standard_assets.lua"

-- Magic Snail

cloneObject{
  name = "magic_snail",
  baseObject = "snail",
  protection = 1000,
  evasion = -100,
  onProjectileHit = function(monster, projectile, damage, damageType) 
    if ( projectile.name == "my_magic_arrow" ) then
	  spawn("fx", monster.level, monster.x, monster.y, monster.facing):setParticleSystem("shockburst"):translate(0,1,0);
	  spawn("fx", monster.level, monster.x, monster.y, monster.facing):setParticleSystem("hit_blood"):translate(0,1,0);
      monster:destroy();
    end
  end,
  onDamage = function(monster, damage, damageType, other)
  	local tracker = findEntity("attack_tracker");
  	
    if ( tracker ~= nil and tracker.getAttackingWeapon() == "knife" ) then
	  spawn("fx", monster.level, monster.x, monster.y, monster.facing):setParticleSystem("shockburst"):translate(0,1,0);
	  spawn("fx", monster.level, monster.x, monster.y, monster.facing):setParticleSystem("hit_blood"):translate(0,1,0);
      monster:destroy();
    end
    
    return false;
  end
}

cloneObject{
  name = "my_magic_arrow",
  baseObject = "arrow",
  uiName = "Magic Arrow"
}

-- Spell 

cloneObject{
  name = "my_magic_spell_rod",
  baseObject = "lightning_rod",
  uiName = "Magic Snail Killer",
  attackMethod = "castWandSpell",
  spell = "kill_magic_snail_spell",
  charges = 100
}

defineSpell{
  name = "kill_magic_snail_spell",
  uiName = "Murder Magic Snail",
  skill = "air_magic",
  level = 10,
  runes = nil,
  manaCost = 0,
  onCast = function(caster, x, y, facing, skill)
  	local dx, dy = getForward(facing);
  	local spell_x, spell_y = x+dx, y+dy;
  	local level = party.level;
  	
  	if ( isWall(level, spell_x, spell_y) ) then
  	  return;
  	end
  	
    spawn("fx", level, spell_x, spell_y, facing):setParticleSystem("shockburst"):translate(0,1,0);
  	 	
    for e in entitiesAt(level, spell_x, spell_y) do
      if ( e.name == "magic_snail" ) then
  	    spawn("fx", level, spell_x, spell_y, facing):setParticleSystem("hit_blood"):translate(0,1,0);      
        e:destroy();
      end
    end
  end
}

-- Melee Weapon

cloneObject{
  name = "party",
  baseObject = "party",
  onAttack = function(champion, weapon) 
  	local tracker = findEntity("attack_tracker");
  	
    if ( tracker ~= nil ) then
		tracker.onAttack(champion, weapon);
    end
  end
}

